<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->


<div class="ls-form">

  <div class="form-group">

    <label
      for="editPasswordInput"
      class="required"
      [innerText]="!!user.id ? messages.NEW_PASSWORD_LABEL : commonMessages.PASSWORD">
    </label>

    <div class="input-group">
      <input
        [disabled]="user.isLdapSynchronized"
        [ngbTooltip]="messages.PASSWORD_CHANGE_DISABLED_LDAP_TOOLTIP"
        [disableTooltip]="!user.isLdapSynchronized"
        [type]="hidePassword ? 'password' : 'text'"
        id="editPasswordInput"
        class="form-control"
        #passwordInput
        required/>

      <span (click)="hidePassword = !hidePassword" class="input-group-text pointer">
        <fa-icon
          [icon]="hidePassword ? eyeSlashIcon : eyeIcon"
          [fixedWidth]="true"
          class="hide-password-button text-center">
        </fa-icon>
      </span>

    </div>
  </div>

  <div
    *ngIf="!user.isLdapSynchronized && !!passwordPolicies"
    class="form-group">

    <div
      *ngIf="passwordPolicies.minLength > 0"
      [ngClass]="{
        'text-success': passwordInput.value.length >= passwordPolicies.minLength,
        'text-danger': passwordInput.value.length < passwordPolicies.minLength
      }">
      <fa-icon
        [icon]="passwordInput.value.length >= passwordPolicies.minLength ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordMinLengthHint(passwordPolicies.minLength)">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.maxLength > 0"
      [ngClass]="{
        'text-success': passwordInput.value.length <= passwordPolicies.maxLength,
        'text-danger': passwordInput.value.length > passwordPolicies.maxLength
      }">
      <fa-icon
        [icon]="passwordInput.value.length <= passwordPolicies.maxLength ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordMaxLengthHint(passwordPolicies.maxLength)">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.notUsername"
      [ngClass]="{
        'text-success': passwordInput.value !== user.userName,
        'text-danger': passwordInput.value === user.userName
      }">
      <fa-icon
        [icon]="passwordInput.value !== user.userName ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.PASSWORD_NOT_USERNAME_HINT">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.notEmail"
      [ngClass]="{
        'text-success': passwordInput.value !== user.email,
        'text-danger': passwordInput.value === user.email
      }">
      <fa-icon
        [icon]="passwordInput.value !== user.email ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.PASSWORD_NOT_EMAIL_HINT">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.specialCharsMinCount > 0"
      [ngClass]="{
        'text-success': countSpecialCharactersFn(passwordInput.value) >= passwordPolicies.specialCharsMinCount,
        'text-danger': countSpecialCharactersFn(passwordInput.value) < passwordPolicies.specialCharsMinCount
      }">
      <fa-icon
        [icon]="countSpecialCharactersFn(passwordInput.value) >= passwordPolicies.specialCharsMinCount ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordSpecialCharacterCountHint(passwordPolicies.specialCharsMinCount)">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.uppercaseCharsMinCount > 0"
      [ngClass]="{
        'text-success': countUppercaseFn(passwordInput.value) >= passwordPolicies.uppercaseCharsMinCount,
        'text-danger': countUppercaseFn(passwordInput.value) < passwordPolicies.uppercaseCharsMinCount
      }">
      <fa-icon
        [icon]="countUppercaseFn(passwordInput.value) >= passwordPolicies.uppercaseCharsMinCount ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordUppercaseCountHint(passwordPolicies.uppercaseCharsMinCount)">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.lowercaseCharsMinCount > 0"
      [ngClass]="{
        'text-success': countLowercaseFn(passwordInput.value) >= passwordPolicies.lowercaseCharsMinCount,
        'text-danger': countLowercaseFn(passwordInput.value) < passwordPolicies.lowercaseCharsMinCount
      }">
      <fa-icon
        [icon]="countLowercaseFn(passwordInput.value) >= passwordPolicies.lowercaseCharsMinCount ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordLowercaseCountHint(passwordPolicies.lowercaseCharsMinCount)">
      </span>
    </div>

    <div
      *ngIf="passwordPolicies.digitsMinCount > 0"
      [ngClass]="{
        'text-success': countDigitsFn(passwordInput.value) >= passwordPolicies.digitsMinCount,
        'text-danger': countDigitsFn(passwordInput.value) < passwordPolicies.digitsMinCount
      }">
      <fa-icon
        [icon]="countDigitsFn(passwordInput.value) >= passwordPolicies.digitsMinCount ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getPasswordDigitsCountHint(passwordPolicies.lowercaseCharsMinCount)">
      </span>
    </div>

    <div
      *ngIf="!!currentCompiledRegex"
      [ngClass]="{
        'text-success': currentCompiledRegex.test(passwordInput.value),
        'text-danger': !currentCompiledRegex.test(passwordInput.value)
      }">
      <fa-icon
        [icon]="currentCompiledRegex.test(passwordInput.value) ? validatedIcon : rejectedIcon"
        [fixedWidth]="true">
      </fa-icon>
      <span
        class="ms-2"
        [innerText]="messages.getRegexHint(passwordPolicies.regexPattern)">
      </span>
    </div>

  </div>

  <div class="form-group">

    <label
      for="editPasswordInputConfirmation"
      class="required"
      [innerText]="messages.CONFIRM_PASSWORD_LABEL">
    </label>

    <div class="input-group">

      <input
        id="editPasswordInputConfirmation"
        class="form-control"
        [disabled]="user.isLdapSynchronized"
        [ngbTooltip]="messages.PASSWORD_CHANGE_DISABLED_LDAP_TOOLTIP"
        [disableTooltip]="!user.isLdapSynchronized"
        [type]="hidePassword ? 'password' : 'text'"
        #passwordConfirmationInput
        required/>

      <span (click)="hidePassword = !hidePassword" class="input-group-text pointer">
        <fa-icon
          [icon]="hidePassword ? eyeSlashIcon : eyeIcon"
          [fixedWidth]="true"
          class="hide-password-button text-center">
        </fa-icon>
      </span>
    </div>
  </div>

</div>
